#!/bin/sh
# Make address list for CML (makecmllist)
#	Copyright 1995,1996 (C) SAITOH-Ely-Yasuhiro.
#	All rights reserved.
VERSION=@VER@

c=
T="`echo 'test\c'`"
if [ "$T" = "test" ]
then
	c="\c"
fi

n=
T="`echo -n 'test'`"
if [ "$T" = "test" ]
then
	n="-n"
fi

#
# Set local environment.
#
DRIVER=@DRIVER@
DOMAIN=@DOMAIN@
AWK=@AWK@
GREP=@GREP@
if [ $# -ne 2 ]
then
	echo "Usage: makecmllist ML-Name Addresslist" 1>&2
	exit 1
fi

ML=$1
ORIG=$2

# Set default value.
. $DRIVER/config.default

if [ -f $DRIVER/$ML/config.$ML ]
then
	. $DRIVER/$ML/config.$ML
fi

# Check change domain name.
if [ "$GENERICFROM" ]
then
	DOMAIN=$GENERICFROM
fi

TEMP=/tmp/MKCML.$$
LIST=/tmp/NEWLI.$$
trap "rm -f $TEMP $LIST; exit 0" 0 1 2 3 15

sed -e 's/(.*)//'  -e 's/.*<//' -e 's/>.*//' < $ORIG | tr , '\012' > $TEMP

KEY=$$
NUM=1
cat /dev/null > $LIST

echo $n "Converting ... $c"

for i in `cat $TEMP`
do
	set $i .
	if [ "$1" = "." ]
	then
		continue
	fi

	ADDRESS=$1
	
	echo $ADDRESS | $GREP @ >/dev/null 2>&1
	if [ $? -ne 0 ]
	then
		ADDRESS="$ADDRESS@$DOMAIN"
	fi


	PID=`expr $KEY + $KEY`

	KEY=`expr 0000$PID : '.*\(....\)$'`

	NUM=`expr 00$NUM : '.*\(...\)$'`

	UI="$NUM SEND <$ADDRESS> $KEY"

	# check default digect
	if [ "$DGSTAPPEND" = "DO" ]
	then
		FROMDOM=`echo $ADDRESS | \
                $AWK '{
                        l = length($0);

                        for ( ; l > 0; l-- ) {
                                printf( "%s", substr( $0, l, 1 ) );
                        }
                        printf( "\n" );
                }' | sed -e 's/@.*//' | \
                $AWK '{
                        l = length($0);

                        for ( ; l > 0; l-- ) {
                                printf( "%s", substr( $0, l, 1 ) );
                        }
                        printf( "\n" );
                }'`

		if [ -f $DRIVER/$ML/defaultdigest ]
		then
			for i in `cat $DRIVER/$ML/defaultdigest`
			do
				echo $FROMDOM | $GREP "$i" >/dev/null 2>&1
				if [ $? -eq 0 ]
				then
					UI="$NUM DGST ($ADDRESS) $KEY <nobody>"
				fi
			done
		fi
	fi
	echo $UI >> $LIST

	NUM=`expr $NUM + 1`
done
echo "Done."

cat $LIST 1>&2

if [ ! -d $DRIVER/$ML ]
then
	mkdir $DRIVER/$ML
fi

if [ -f $DRIVER/$ML/$ML-list ]
then
	mv $DRIVER/$ML/$ML-list $DRIVER/$ML/$ML-list.orig
fi
cat $LIST > $DRIVER/$ML/$ML-list

exit 0
